// file      : xsd-frontend/traversal/schema.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef XSD_FRONTEND_TRAVERSAL_SCHEMA_HXX
#define XSD_FRONTEND_TRAVERSAL_SCHEMA_HXX

#include <xsd-frontend/traversal/elements.hxx>
#include <xsd-frontend/semantic-graph/schema.hxx>

namespace XSDFrontend
{
  namespace Traversal
  {
    //
    //
    struct Implies : Edge<SemanticGraph::Implies>
    {
      virtual Void
      traverse (Type& e)
      {
        dispatch (e.element ());
      }
    };


    //
    //
    struct Sources : Edge<SemanticGraph::Sources>
    {
      virtual Void
      traverse (Type& e)
      {
        dispatch (e.element ());
      }
    };


    //
    //
    struct Includes : Edge<SemanticGraph::Includes>
    {
      virtual Void
      traverse (Type& e)
      {
        dispatch (e.element ());
      }
    };


    //
    //
    struct Imports : Edge<SemanticGraph::Imports>
    {
      virtual Void
      traverse (Type& e)
      {
        dispatch (e.element ());
      }
    };


    //
    //
    struct Schema : ScopeTemplate<SemanticGraph::Schema>
    {
      virtual Void
      traverse (Type& s)
      {
        pre (s);

        iterate_and_dispatch (s.contains_begin (),
                              s.contains_end (),
                              edge_traverser ());

        names (s);

        post (s);
      }

      virtual Void
      pre (Type&)
      {
      }

      virtual Void
      post (Type&)
      {
      }
    };
  }
}

#endif  // XSD_FRONTEND_TRAVERSAL_SCHEMA_HXX
